package shay.org.ext;

import java.io.BufferedReader;
import java.io.File;
import java.io.InputStreamReader;

import java.io.PrintWriter;

import java.net.URL;

import java.util.ArrayList;
import java.util.List;

import javax.swing.Icon;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JTextField;

import oracle.bali.ewt.dialog.JEWTDialog;

import oracle.ide.Addin;
import oracle.ide.Context;
import oracle.ide.Ide;
import oracle.ide.controller.Controller;
import oracle.ide.controller.IdeAction;
import oracle.ide.controller.Menubar;
import oracle.ide.dialogs.OnePageWizardDialogFactory;
import oracle.ide.dialogs.WizardLauncher;
import oracle.ide.keyboard.KeyStrokeContextRegistry;
import oracle.ide.log.Href;
import oracle.ide.log.LogManager;
import oracle.ide.net.URLTempFile;
import oracle.ide.util.GraphicsUtils;
import oracle.ide.webbrowser.BrowserRunner;
/*
 * This extension adds a menu option to the Help menu
 * The option "Search Blogs" searches for the words specified in a repository
 * of blog entries that were indexed by the JDeveloper team.
 *
 * Created by Shay Shmeltzer
 * February 2008
 */


public final class HowToSearch implements Addin, Controller {
    public static final int SEARCH_HOWTO_CMD_ID = 
        Ide.findOrCreateCmdID("SEARCH_HOWTO_CMD_ID");
    static MessageWindow gmp = null;
    String title = "";
    URL url;

    public boolean handleEvent(IdeAction action, Context context) {
        int cmdId = action.getCommandId();
        String msg = null;
        //create and open the dialog
        if (cmdId == SEARCH_HOWTO_CMD_ID) {
            JTextField tx = new JTextField();
            JEWTDialog dlg = 
                OnePageWizardDialogFactory.createJEWTDialog(tx, null, 
                                                            "Enter Search Terms");
            dlg.setDefaultButton(JEWTDialog.BUTTON_OK);
            dlg.setOKButtonEnabled(true);

            boolean go = WizardLauncher.runDialog(dlg);
            if (go) {
                try {
                    LogManager.getLogManager().showLog();
                    if (gmp == null) {
                        gmp = new MessageWindow("Serach Blogs Results");
                    }
                    gmp.show();
                    gmp.log("\n");
                    gmp.log("Here is what we found for " + tx.getText());
                    gmp.log("\n");

                    try {
                        URL rssurl = 
                            new URL("http://www.connotea.org/rss/user/jdeveloper?q=" + 
                                    convert(tx.getText()));
                        BufferedReader in = 
                            new BufferedReader(new InputStreamReader(rssurl.openStream()));

                        String inputLine;
                        int i = 1;
                        //                        inputLine = in.readLine();
                        while ((inputLine = in.readLine()) != null) {
                            if (inputLine.startsWith("<title>")) {
                                title = 
                                        (inputLine.substring(7, inputLine.length() - 
                                                             8));
                            }
                            if (inputLine.startsWith("<dcterms:URI")) {
                                gmp.log(i++);
                                url = 
new URL(inputLine.substring(24, inputLine.length() - 2));
                                try {
                                    final String tl = title;
                                    final URL ul = url;
                                    Href href = new Href(tl, ul) {
                                            public void go() {
                                                oracle.ide.webbrowser.BrowserRunner.getBrowserRunner().runBrowserOnURL(ul, 
                                                                                                                       null, 
                                                                                                                       null);
                                            }
                                        };
                                    gmp.log(href);
                                } catch (Exception e) {
                                    System.out.println(e);
                                }
                                gmp.log("\n");

                            }

                        }


                    } catch (Exception e) {
                        System.out.println(e);
                    }
                } catch (Exception e) {
                    System.out.println(e);
                }
            }
        }

        if (msg != null) {
            logMessage(msg);
            Ide.getStatusBar().setText(msg);
            return true;
        }
        return false;
    }


    private static final void logMessage(String msg) {
        LogManager.getLogManager().showLog();
        LogManager.getLogManager().getMsgPage().log(msg + "\n");
    }

    static boolean enableElementInfo(Context context) {
        return true;
    }

    public boolean update(IdeAction action, Context context) {
        int cmdId = action.getCommandId();

        if (cmdId == SEARCH_HOWTO_CMD_ID) {
            action.setEnabled(enableElementInfo(context));
            return true;
        }
        return false;
    }

    public void initialize() {
        // Create the Context Menu Item and add it to the Navigator Menu
        Controller ctrlr1 = this;
        JMenuItem mi = 
            doCreateMenuItem(ctrlr1, "Search Blogs ...", new Integer('O'));
        JMenu jmenu = Menubar.getJMenu("Help");
        jmenu.add(mi);
        KeyStrokeContextRegistry r = Ide.getKeyStrokeContextRegistry();
        r.addAcceleratorDefinitionFile(HowToSearch.class.getClassLoader(), 
                                       "META-INF/accelerators.xml");
    }

    private static JMenuItem doCreateMenuItem(Controller ctrlr, 
                                              String menuLabel, 
                                              Integer mnemonic) {
        // Icon associated with this IdeAction
        //        Icon icon = null;
        Icon icon = 
            GraphicsUtils.createImageIcon(GraphicsUtils.loadFromResource("lov_ena.png", 
                                                                         HowToSearch.class));
        // Category (if any) associated with this IdeAction
        String category = "Search";
        // Name of class which extends oracle.ide.addin.AbstractCommand
        String cmdClass = null;

        // This can be retrieved via IdeAction.find(MY_MENU_COMMAND_ID)
        IdeAction actionTM = // int cmdId,
            // extends oracle.ide.addin.AbstractCommand
            // String name,
            // Category
            // Integer mnemonic,
            // Icon icon,
            // Object data,
            // boolean enabled
            IdeAction.get(SEARCH_HOWTO_CMD_ID, cmdClass, menuLabel, category, 
                          mnemonic, icon, null, true);

        actionTM.addController(ctrlr);
        JMenuItem menuItem = Ide.getMenubar().createMenuItem(actionTM);
        return menuItem;
    }


    private String convert(String string) {
        return string.replace(' ', '+');

    }
}

